function asccode(STRING,  chstr) {
	chstr = " !\"#$%&'()*+,-./0123456789:;<=>?"
	chstr = chstr "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_"
	chstr = chstr " abcdefghijklmnopqrstuvwxyz{|}~ "
	return index(chstr,STRING)+31
}

BEGIN {
	labelcnt = 1
	linecnt = 1
}

{

# Rg폜
	gsub(/'.*/,"'")

# r܂œxύX
	gsub(/GETD2/,"GET_D2")
	gsub(/N\.CODE2/,"N_CODE2")
	gsub(/C\.COLOR1 */,"C1COL")
	gsub(/C\.COLOR2 */,"C2COL")

# ϐQɂ
	gsub(/NFAD/,"NF")
	gsub(/FAD/,"FD")
	gsub(/EAD/,"ED")
	gsub(/PAGE\.NO/,"PG")
	gsub(/GDR/,"GR")
	gsub(/GNO/,"GN")
	gsub(/BGMM/,"BM")
	gsub(/BGMN/,"BN")
	gsub(/BGXX/,"BX")
	gsub(/GST/,"GS")
	gsub(/SST/,"SS")
	gsub(/WASA/,"WS")
	gsub(/MVA/,"VA")
	gsub(/MVE/,"VE")
	gsub(/MOB/,"OB")
	gsub(/VSB/,"SB")
	gsub(/VAR/,"AR")
	gsub(/PUX/,"UX")
	gsub(/COM\.TOP\.ADD/,"CD")
	gsub(/VSM/,"SM")
	gsub(/SELE\.LO/,"SL")
	gsub(/SELE\.P/,"SP")
	gsub(/SELE\.A/,"SA")
	gsub(/SELE\$/,"SL$")
	gsub(/POSE/,"PE")
	gsub(/SPOS/,"PS")
	gsub(/FRONT/,"FR")
	gsub(/ANS/,"AN")
	gsub(/VNO/,"VN")
	gsub(/ONO/,"OO")
	gsub(/NVA/,"NV")
	gsub(/DISK\(/,"DS(")
	gsub(/PDS/,"PD")
	gsub(/LNN/,"NN")
	gsub(/GDX/,"GX")
	gsub(/DUMMY/,"DM")
	gsub(/PICNO/,"PN")
	gsub(/SGD/,"SG")
	gsub(/PDHX/,"PX")
	gsub(/PDHY/,"PY")
	gsub(/ESCM/,"ES")
	gsub(/AAS/,"AA")

# R}h̕ύXȂ
	gsub(/WRITE/,"PRINT")
	gsub(/POLL/,"VIEW")
	gsub(/COLOR */,"&9+")
	gsub(/STATUS SET */,"WINDOW #")
	gsub(/STATUS CALL */,"WINDOW ")
	gsub(/STATUS\(/,"WINDOW(")
	gsub(/CLS *3/,"CLS")
	gsub(/DEFINT *A-Z:*/,"")

# &H8000` ̏
	gsub(/&H[8-9A-F][0-9A-F][0-9A-F][0-9A-F]/,"&+65536")

# LINȄ
	while (match($0,/LINE/) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART)
		sub(/LINE/,"@@LNDMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,",9+",ln2)
		gsub(/@@DUMMY@@/,"/2,",ln2)
		$0 = ln1 ln2
	}
	gsub(/@@LNDMY@@/,"LINE")

# PAINT̏
	while (match($0,/PAINT/) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART)
		sub(/PAINT/,"@@PNDMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,"@@CLDMY@@",ln2)
		sub(/,/,"@@CLDMY@@",ln2)
		gsub(/@@DUMMY@@/,"/2,",ln2)
		gsub(/@@CLDMY@@/,",9+",ln2)
		$0 = ln1 ln2
	}
	gsub(/@@PNDMY@@/,"PAINT")

# LOCATȄ
	while (match($0,/LOCATE */) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART+RLENGTH)

		lne = match(ln2,/:/)
		lnc = match(ln2,/,/)
		if (lnc == 0 || (lne != 0 && lnc > lne) ) {
			if (match(ln2,/:/) != 0) {
				lnx = substr(ln2,1,RSTART-1)
				ln2 = substr(ln2,RSTART)
			} else {
				lnx = ln2
				ln2 = ""
			}
			lny = "CSRLIN"
		} else {
			match(ln2,/,/)
			lnx = substr(ln2,1,RSTART-1)
			ln2 = substr(ln2,RSTART+RLENGTH)
			if (match(ln2,/:/) != 0) {
				lny = substr(ln2,1,RSTART-1)
				ln2 = substr(ln2,RSTART)
			} else {
				lny = ln2
				ln2 = ""
			}
		}
		$0 = ln1 "ZX=" lnx ":ZY=" lny ":GOSUB 10000" ln2
	}


# RETURN sԍ̏
	gsub(/GOSUB *\*BETA\.OUT/,"&:ON RR GOTO 50,6000,20")
	gsub(/RETURN *50/,"RR=1:RETURN")
	gsub(/RETURN *\*LOAD\./,"RR=2:RETURN")
	gsub(/RETURN *\*MAIN\.LOOP/,"RR=3:RETURN")
	if ($1 == "4010") {
		gsub(/RETURN/,"RR=0:RETURN")
	}


# ʕύX
	gsub(/SWAP UP,GD/,"XX=UP:UP=GD:GD=XX")

	if ($1 == 30) {
		sub(/:$/,"")
	}
	if ($1 == 40) {
		sub(/CVI\(CHR\$\(WINDOW\(0\)\)\+CHR\$\(WINDOW\(1\)\)\)/,"WINDOW(0)+256*WINDOW(1)")
		sub(/:'$/,"")
	}
	if ($1 == 100) {
		sub(/MATA/,"MA")
	}
	if ($1 == 110) {
		sub(/CALL MATA\(/,"CMD MA,4,2,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 380) {
		sub(/CALI/,"CA")
		sub(/CALL CALI\(/,"CMD CA,5,2,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 450) {
		sub(/EPASS/,"EP")
		sub(/D743/,"D706")
		sub(/CALL EPASS\(/,"CMD EP,4,0,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 >= 470 && $1 <= 630 || $1 == 650 || $1 == 670) {
		sub(/GD\$/,"GD")
		match($0,/"."/)
		asc = sprintf("\\&H%02X",asccode( substr($0,RSTART+1,1) ) )
		sub(/"."/,asc)
	}
	if ($1 == 620 || $1 == 640) {
		gsub(/A\$/,"A")
		gsub(/GD\$/,"GD")
		sub(/CVI\(A\+GD\)/,"A+256*GD")
	}
	if ($1 == 700) {
		sub(/PYY=CSRLIN:/,"")
	}
	if ($1 == 710) {
		$0 = $1 " GOSUB 11000"
	}
	if ($1 == 711 || $1 == 712 || $1 == 719) {
		$0 = $1 " REM"
	}
	if ($1 == 740 || $1 == 745) {
		sub(/PRINT \" \";/,"ZX=1:ZY=CSRLIN:GOSUB 10000")
	}
	if ($1 == 790) {
		sub(/KAKKO/,"KA")
		sub(/CALL KAKKO\(/,"CMD KA,4,0,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 830) {
		sub(/:GD\$.*/,"")
	}
	if ($1 == 860 || $1 == 870) {
		sub(/GD\$/,"CHR$(GD)")
	}
	if ($1 == "905") {
		sub(/ /," EXEC \\&H0123:")
	}
	if ($1 == "980") {
		$0 = $1 " PK=KEY(0):XX=RND(1)"
	}
	if ($1 == "990") {
		sub(/IF PK AND 1/,"IF PK=30")
	}
	if ($1 == "1000") {
		sub(/IF PK AND 2/,"IF PK=31")
	}
	if ($1 == "1010") {
		sub(/IF PK AND 8/,"IF PK=28")
	}
	if ($1 == "1020") {
		sub(/IF PK AND 4/,"IF PK=29")
	}
	if ($1 == "1030") {
		sub(/IF PK AND 16/,"IF PK=13 OR PK=32")
		sub(/WHILE.*WEND:/,"")
		sub(/RETURN:.*/,"RETURN")
	}
	if ($1 == "1031") {
		gsub(/IF PK AND 32/,"IF PK=27")
	}
	if ($1 >= 1120 && $1 <= 1180) {
		$0 = $1 " REM"
	}
	if ($1 == 2801) {
		sub(/CLOSE:/,"CLOSE:FL=DK+1:GOSUB 12000:")
	}
	if ($1 == 2830) {
		$0 = $1 " IF KEY(0)<>0 THEN 2830"
	}
	if ($1 == 2832) {
		$0 = $1 " IF KEY(0)=0 THEN 2832"
	}
	if ($1 == 2850) {
		sub(/ /," FL=DK+1:GOSUB 12000:")
	}
	if ($1 == 2860) {
		sub(/ /," WINDOW #1:")
	}
	if ($1 == 3010) {
		sub(/GS\(GD-1\)\\255/,"INT(GS(GD-1)/256)")
	}
	if ($1 == 3051) {
		sub(/GOTO/,"FL=1:GOSUB 12000:GOTO")
	}
	if ($1 == 3052) {
		sub(/GOTO/,"FL=2:GOSUB 12000:GOTO")
	}
	if ($1 == 3055) {
		sub(/GR>5/,"GR>3")
		gsub(/BEEP/,"PRINT CHR$(7)")
	}
	if ($1 == 3090) {
		sub(/RBYTE/,"OPEN")
		sub(/COLOR.*/,"FOR INPUT AS#2:WINDOW #2:WINDOW GN:SET 9+UP:CLOSE #2")
	}
	if ($1 == 3110) {
		sub(/RETURN.*/,"RETURN")
	}
	if ($1 == 4011) {
		sub(/:'$/,"")
	}
	if ($1 == 5001) {
		$0 = $1 " REM"
	}
	if ($1 == 5010) {
		$0 = $1 " CLEAR 50,&HB000"
	}
	if ($1 == 5020 || $1 == 5031 || $1 == 5050 || $1 == 5051) {
		$0 = $1 " REM"
	}
	if ($1 == 5030) {
		sub(/:ON STOP.*/,"")
	}
	if ($1 == 5040) {
		$0 = $1 " BLOAD \"arrow.bin\""
	}
	if ($1 == 5045) {
		$0 = $1 " WS=PEEK(&HD100)+256*PEEK(&HD101)"
	}
	if ($1 == 5051) {
		sub(/BM=1:/,"")
		sub(/:POKE.*/,"")
	}
	if ($1 == 5060) {
		sub(/:WLOAD.*/,":PN=0")
	}
	if ($1 == 5110) {
		sub(/,PD.*/,"")
	}
	if ($1 == 5170) {
		sub(/GET/,"WINDOW ")
		sub(/,2$/,":WINDOW 0")
	}
	if ($1 == 5171) {
		sub(/255/,"152")
		sub(/CVI\(INPUT\$\(2,2\)\)/,"WINDOW(I*2)+256*WINDOW(I*2+1)")
	}
	if ($1 == 5180) {
		sub(/$/,":WINDOW 0")
	}
	if ($1 == 5189 || $1 == 5190 || $1 == 6560) {
		sub(/:'$/,"")
	}
	if ($1 == 6560) {
		sub(/POKE.*&HC3:/,"")
		sub(/:POKE.*&HC9/,"")
	}
	if ($1 == 6570) {
		gsub(/$/,":WINDOW NN:DM=WINDOW(0)")
	}
	if ($1 == 6600) {
		gsub(/$/,":EXEC \\&H0123")
	}
	if ($1 == 6610) {
		$0 = $1 " PK=KEY(0):XX=RND(1)"
	}
	if ($1 == 6620) {
		sub(/IF PK AND 1/,"IF PK=30")
	}
	if ($1 == 6630) {
		sub(/IF PK AND 2/,"IF PK=31")
	}
	if ($1 == 6640) {
		sub(/IF PK AND 16/,"IF PK=13 OR PK=32")
	}
	if ($1 == 6641) {
		sub(/IF PK AND 32/,"IF PK=27")
	}
	if ($1 == 8030) {
		sub(/CLS 2/,"CLS")
	}
	if ($1 == 9210) {
		sub(/620/,"220")
	}
	if ($1 == 9220) {
		$0 = $1 " IF KEY(0)=13 THEN AR(0)=1:AA=220"
	}
	if ($1 >= 9310 && $1 <= 9340) {
		$0 = $1 " REM"
	}
	if ($1 >= 9360 && $1 <= 9390) {
		$0 = $1 " REM"
	}
	if ($1 == 9410) {
		sub(/\(RND\)/,"RND(1)")
	}
	if (($1 >= 9530 && $1 <= 9550) || ($1 >= 9620 && $1 <= 9640)) {
		gsub(/\(/,"((")
		gsub(/\//,")/")
	}
	if ($1 == 10000) {
		$0 = $1 " POKE &HEC7C,2:POKE &HECA0,80:LOCATE ZX,ZY:POKE &HEC7C,1:POKE &HECA0,40:RETURN"
	}
	if ($1 == 10010) {
		$0 = $1 " REM"
	}
	if ($1 >= 20000 && $1 <= 20990) {
		$0 = $1 " REM"
	}
	if ($1 == 21001 || $1 == 21015 || $1 == 21020) {
		$0 = $1 " REM"
	}
	if ($1 >= 21010 && $1 <= 21013) {
		sub(/RESTORE/,"EXEC")
		sub(/20000/,"\\&HB800")
		sub(/20100/,"\\&HB805")
		sub(/20200/,"\\&HB80A")
		sub(/20300/,"\\&HB80F")
	}
	if ($1 == 30020) {
		$0 = $1 " EXEC &HDF09"
	}
	if ($1 == 30060) {
		$0 = $1 " EXEC &HDF03:EXEC &HDF06"
	}
	if ($1 == 50030) {
		sub(/CLS 2/,"CLS")
	}
	if ($1 == 50050) {
		$0 = $1 " GOSUB 11000"
	}
	if ($1 == 60000) {
		sub(/BEEP 1:BEEP 0/,"PRINT CHR$(7)")
	}
	if ($1 == 60002) {
		$0 = $1 " IF BM<>0 THEN EXEC &HDF09"
	}
	if ($1 == 60003) {
		$0 = $1 " REM"
	}


# x̋LƃRgAEg
	if ( substr($2,1,1) == "*") {
		match($0,/ /)
		tmp1 = substr($0,RSTART+2)
		if ( match(tmp1,/:/) == 0) {
			tmp2 = "'"
			tmp3 = tmp1
		} else {
			tmp2 = substr(tmp1,RSTART+1)
			tmp3 = substr(tmp1,1,RSTART-1)
		}
		$0 = $1 " "tmp2
		gsub(/\./,"\\.",tmp3)
		label[labelcnt] = "\\*" tmp3
		labelnum[labelcnt] = $1
		labelcnt ++
	}


	linebuf[linecnt] = $0
	linecnt ++

}

END {
	wflag = 0
	for (i = 1;i < linecnt;) {
		for (j = 1;j < labelcnt;j ++) {
			gsub(label[j],labelnum[j],linebuf[i])
		}

# WHILE - WEND 

		match(linebuf[i+1],/[^0-9 ]/)
		n_num = substr(linebuf[i+1],1,RSTART-1)

		match(linebuf[i]  ,/[^0-9 ]/)
		c_num = substr(linebuf[i],1,RSTART-1)
		c_line = substr(linebuf[i],RSTART)

		c_if = match(c_line,/IF/)
		c_wl = match(c_line,/WHILE/)
		c_wd = match(c_line,/WEND/)

		match(c_line,/[ :]*WHILE/)
		c_b_wl = substr(c_line,1,RSTART-1)

		match(c_line,/WHILE */)
		c_x_wl = substr(c_line,RSTART+RLENGTH)
		if (match(c_x_wl,/ *:/) != 0) {
			c_x_wl = substr(c_x_wl,1,RSTART-1)
		}

		if (match(c_line,/WHILE *[^:]*:/) == 0) {
			c_e_wl = ""
		} else {
			c_e_wl = substr(c_line,RSTART+RLENGTH)
		}

		match(c_line,/WHILE *[^:]*:/)
		c_m_wl = substr(c_line,RSTART+RLENGTH)
		match(c_m_wl,/[ :]*WEND/)
		c_m_wl = substr(c_m_wl,1,RSTART-1)

		match(c_line,/[ :]*WEND[ :]*/)
		c_e_wd = substr(c_line,RSTART+RLENGTH)

		match(c_line,/[ :]*WEND/)
		c_b_wd = substr(c_line,1,RSTART-1)


		if (c_wl != 0) {
			if (c_if != 0 && c_if < c_wl) {
				print "Error!! IF before WHILE"
				print linebuf[i]
			} else {
				if (c_wd != 0) {
					if (n_num-c_num < 5) {
						print "Error!! LineNumber"
						print linebuf[i]
						print linebuf[i+1]
					} else {
						if (c_b_wl == "") {
							c_b_wl = "'"
						}
						if (c_e_wd == "") {
							c_e_wd = "'"
						}
						print c_num+0 " " c_b_wl
						print c_num+1 " " "IF " c_x_wl " THEN " c_num+3
						print c_num+2 " " "GOTO " c_num+4
						print c_num+3 " " c_m_wl ":GOTO " c_num+1
						print c_num+4 " " c_e_wd
					}
				} else {

					wflag = c_num+1
					if (n_num-c_num < 4) {
						print "Error!! LineNumber"
						print linebuf[i]
						print linebuf[i+1]
					} else {

						w_num = c_num

						i ++
						for (j = 1;c_wd == 0;j++) {
							wbuf[j] = linebuf[i]
							c_wd = match(wbuf[j],/WEND/)
							i ++
						}
						j --
						i --

						match(linebuf[i+1],/[^0-9 ]/)
						n_num = substr(linebuf[i+1],1,RSTART-1)

						match(linebuf[i]  ,/[^0-9 ]/)
						c_num = substr(linebuf[i],1,RSTART-1)
						c_line = substr(linebuf[i],RSTART)


						if (c_b_wl == "") {
							c_b_wl = "'"
						}
						if (c_e_wl == "") {
							c_e_wl = "'"
						}
						print w_num+0 " " c_b_wl
						print w_num+1 " " "IF " c_x_wl " THEN " w_num+3
						print w_num+2 " " "GOTO " c_num+1
						print w_num+3 " " c_e_wl

						for (k = 1;k < j;k ++) {
							print wbuf[k]
						}

						match(c_line,/[ :]*WEND[ :]*/)
						c_e_wd = substr(c_line,RSTART+RLENGTH)

						match(c_line,/[ :]*WEND/)
						c_b_wd = substr(c_line,1,RSTART-1)

						if (n_num-c_num < 2) {
							print "Error!! LineNumber"
							print wbuf[j]
							print wbuf[j+1]
						} else {
							if (c_e_wd == "") {
								c_e_wd = "'"
							}
							print c_num+0 " " c_b_wd ":GOTO " wflag
							print c_num+1 " " c_e_wd
							wflag = 0
						}

					}

				}
			}

		} else {
			print linebuf[i]
		}

		if (match(linebuf[i],/^5010 /) != 0) {
			print "5011 BLOAD \"MSK1\":POKE &HD398,&H00:POKE &HD399,&H20:EXEC &HD383"
			print "5012 BLOAD \"MSK2\":POKE &HD398,&H20:POKE &HD399,&H20:EXEC &HD383"
			print "5013 IF PEEK(&HDFFF)=0 THEN BLOAD \"MSK3\",&HB900:BLOAD \"MSK4\",&HF000:GOTO 5016"
			print "5014 BLOAD \"MSK3\":POKE &HD398,&H40:POKE &HD399,&H17:EXEC &HD383"
			print "5015 BLOAD \"MSK4\":POKE &HD398,&H57:POKE &HD399,&H10:EXEC &HD383"
			print "5016 CLEAR 2000,&HB800:BM=PEEK(&HDFFD)"
		}

		if (match(linebuf[i],/^10010 /) != 0) {
			print "11000 EXEC &H0123"
			print "11010 XX=RND(1):IF KEY(0)=0 THEN 11010"
			print "11020 XX=RND(1):IF KEY(0)<>0 THEN 11020"
			print "11030 RETURN"
			print "12000 IF PEEK(&HDFFE)=0 THEN RETURN"
			print "12010 CHAIN 2,\"INTRP6_\"+CHR$(65+FL):RETURN"

		}

		i ++

	}

}
