
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXBUF	0x2000

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		num,c,tim,i;
	int		buf[MAXBUF];
	int		add;
	int		offset;

	if (argc != 3) {
		fprintf(stderr, "Usage: convfmtim infile outfile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	num = 0;
	while ((c = fgetc(infp)) != EOF) {
		if (num > MAXBUF) {
			printf("File length error\n");
			exit(1);
		}
		buf[num] = c;
		num ++;
	}

	offset = 0x7878 - 0x6000;
	for (tim = 0;tim < 21;tim ++) {
		add = buf[tim*2+offset] + buf[tim*2+offset+1]*0x100 - 0x6000;
		for (i = 0;i < 25;i ++) {
			fputc(buf[add+i],outfp);
		}
	}

	offset = 0x79ca - 0x6000;
	for (;tim < 62;tim ++) {
		add = offset + (tim-21)*37;
		for (i = 0;i < 25;i ++) {
			fputc(buf[add+i],outfp);
		}
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}
